--[[
    https://wow.gamepedia.com/API_Frame_SetClampedToScreen
    https://github.com/tomrus88/BlizzardInterfaceCode/blob/master/Interface/FrameXML/GameTooltip.lua#L159-L162
]]

local _, addonTable = ...
local config = addonTable.config

local function setDefaultAnchor(self, parent)
    self:SetOwner(parent, 'ANCHOR_NONE')
    self:ClearAllPoints()

    if config.unlockPosition then
        self:SetPoint(config.point, config.relativeFrame, config.relativePoint, config.offsetX, config.offsetY)
    else
        self:SetPoint('BOTTOMRIGHT', UIParent, 'BOTTOMRIGHT', -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y)
    end

    if config.anchorToCursor and not InCombatLockdown() and GetMouseFocus() == WorldFrame then
        self:SetOwner(parent, config.cursorAnchorType, config.cursorOffsetX, config.cursorOffsetY)
    end

    -- This will flag the tooltip as having been anchored using the default anchor
    self.default = 1
end

hooksecurefunc('GameTooltip_SetDefaultAnchor', setDefaultAnchor)